-- _ buAlignVertex.mcr Ver.0.9
-- ؘaG kasiwagi@ummb.jp
-- XN[WŒ_cɐ񂵂܂B
-- }EXNbNʒuɑ@\܂B
-- 
-- 0.9 ŏ̃o[W
-- ̗\
-- |modɑΉȂʖڂ˂

macroScript buAlignVertex
	category:"Bu"
	buttontext:"buAlignVertex"
	toolTip:"buAlignVertex" 
(

	fn getViewXY mode = -- r[|[g̎ԂB
	(
		if 5 > mode then
			return (Inverse(getViewTM())).row1
		else
			return (Inverse(getViewTM())).row2
	)

	fn getCPlane mode = -- NbNp
	(
		local p = pickpoint snap:#3D
		if p == #escape or p == #rightClick or classOf p == String do return false
		local axis = getViewXY mode -- r[؂ւĂ̑΍
		return ray (axis*(dot p axis)) axis
	)

	fn getIPlane verts mode m = -- őŏ_
	(
		local axis = getViewXY mode
		local ar = for i in verts collect ( dot i axis ) -- ˉez
		local t = case m of
					(
						1: amin ar
						2: amax ar
						3: ((amin ar) + (amax ar))/2
					)
		return ray (axis*t) axis
	)

	fn getAlignPlane verts mode = -- pʎ擾
	(
		case mode of
		(
			1: return getIPlane verts mode 1 -- 
			2: return getIPlane verts mode 3 -- 
			3: return getCPlane mode -- NbNw
			4: return getIPlane verts mode 2 -- E
			5: return getIPlane verts mode 2 -- 
			6: return getIPlane verts mode 3 -- 
			7: return getCPlane mode -- NbNw
			8: return getIPlane verts mode 1 -- 
		)
	)

	fn buAlign mode =
	(
		undo "buAlignVertex" on
		(
			local obj = selection[1]
			local sV = case subObjectLevel of -- I𒸓_̃Zbg
			(
				1: polyop.getVertSelection obj
				2: polyop.getVertsUsingEdge obj #selection
				4: polyop.getVertsUsingFace obj #selection
			)
			if sV == undefined do return()
			sV = sV as array
			if sV.count == 0 do return()

			local verts = for i in sV collect polyop.GetVert obj i -- I𒸓_̍Wz
			local alignPlane = getAlignPlane verts mode
			if alignPlane == false do return()
			
			for i = 1 to sV.count do
			(
				local vp = verts[i]
				local h = dot (vp - alignPlane.pos) alignPlane.dir
				polyop.setVert obj sV[i] (vp - alignPlane.dir*h)
			)
		)
	)

	rollout buAlignVertexRoll "buAlignVertex" width:148
	(
		button btnA1 "Un" pos:[  4, 4] width:32 height:24 images:#("buAlignVertex.bmp", "buAlignVertexM.bmp", 8, 1, 1, 1, 1)
		button btnA2 "Is" pos:[ 40, 4] width:32 height:24 images:#("buAlignVertex.bmp", "buAlignVertexM.bmp", 8, 2, 2, 2, 2)
		button btnA3 "S1" pos:[ 76, 4] width:32 height:24 images:#("buAlignVertex.bmp", "buAlignVertexM.bmp", 8, 3, 3, 3, 3)
		button btnA4 "S2" pos:[112, 4] width:32 height:24 images:#("buAlignVertex.bmp", "buAlignVertexM.bmp", 8, 4, 4, 4, 4)
		button btnA5 "Rf" pos:[  4,31] width:32 height:24 images:#("buAlignVertex.bmp", "buAlignVertexM.bmp", 8, 5, 5, 5, 5)
		button btnA6 "sp" pos:[ 40,31] width:32 height:24 images:#("buAlignVertex.bmp", "buAlignVertexM.bmp", 8, 6, 6, 6, 6)
		button btnA7 "RI" pos:[ 76,31] width:32 height:24 images:#("buAlignVertex.bmp", "buAlignVertexM.bmp", 8, 7, 7, 7, 7)
		button btnA8 "RO" pos:[112,31] width:32 height:24 images:#("buAlignVertex.bmp", "buAlignVertexM.bmp", 8, 8, 8, 8, 8)

		on btnA1 pressed do buAlign 1
		on btnA2 pressed do buAlign 2
		on btnA3 pressed do buAlign 3
		on btnA4 pressed do buAlign 4
		on btnA5 pressed do buAlign 5
		on btnA6 pressed do buAlign 6
		on btnA7 pressed do buAlign 7
		on btnA8 pressed do buAlign 8
	) -- rollout

	-- _CAO쐬
	global buAlignVertexPos = [200,100]
	on isChecked do buAlignVertexRoll.open
	on execute do createDialog buAlignVertexRoll pos:buAlignVertexPos
	on closeDialogs do
	(
		buAlignVertexPos = GetDialogPos buAlignVertexRoll
		destroyDialog buAlignVertexRoll
	)
)

